#!/usr/bin/perl

use CGI qw(:standard);
use DBI;
srand(time);

$htmldir= "http://www.mikespice.com";


## main program ###
$cur=CGI->new();
getconfig();
printstarthtml();

$mode = "default";
if($cur->param("mode")) {
	$mode = $cur->param("mode");
}
if($mode eq "default") {
	printquiz()
}
if($mode eq "grademe") {
	grademe();
}

printendhtml();








### SUBROUTINES  ###
sub printstarthtml {
print <<HTMLHEADER;
Content-type: text/html


<html>
<head>
    <title>$title</title>
</head>
<body bgcolor="$bgcolor">
HTMLHEADER
	if($logo) {
		print"<center><img src=\"$htmldir/$logo\" alt=\"$title\"></center>";
	} else {
	}
}
sub printendhtml {
print <<HTMLEND
<br><hr><font size=-1>Service provided by <a href="http://www.mikespice.com">MikeSpice.com</a>.  Copyright 2000 by MikeSpice.</font><br>
</body>
</html>
HTMLEND

}

sub getconfig {
	#getting config file
	if($cur->param("quiz")) {
		$quiz_file = $cur->param("quiz");
	} else {
		dietext("You must specify which quiz you would like to take.");
	}

	#setting default values in case they are not in the config file
	$title= "Quiz from MikeSpice.com";
	$logo= "";
	$bgcolor = "#FFFFFF";
	$tablecolor= "#E0D5E5";
	$darkrowcolor= "#A967E2";
	$gradeby = "percent";
	
	open(CONFIG,"$quiz_file.dat") || dietext("Could not open the quiz file.  Contact the server admin.");
	flock(CONFIG,2); #keep others from messin while we are here

	while(<CONFIG>) {
		chomp;
		if($_ =~ /^\#/) {
			$_ =""; #make sure that I ignore all commented lines
		}
		if($_ =~ /^title\s*=\s*/) {
			($nothing,$title)=split(/=/,"$_");
		}
		if($_ =~ /^logo\s*=\s*/) {
			($nothing,$logo)=split(/=/,"$_");
		}
		if($_ =~ /^background\s*=\s*/) {
			($nothing,$bgcolor)=split(/=/,"$_");
		}
		if($_ =~ /^tablecolor\s*=\s*/) {
			($nothing,$tablecolor)=split(/=/,"$_");
		}
		if($_ =~ /^darkrowcolor\s*=\s*/) {
			($nothing,$darkrowcolor)=split(/=/,"$_");
		}
		if($_ =~ /^gradeby\s*=\s*/) {
			($nothing,$gradeby)=split(/=/,"$_");
		}

			
	}
	close(CONFIG);
}

sub printquiz {
	print <<HTML;
<center>
<form method="post">
<table width =600 cellspacing="0" border="0" bgcolor="$tablecolor">
<tr bgcolor="$darkrowcolor"><td align="middle"><font color=white><b>$title</b></font></td></tr>
<tr><td align="middle">&nbsp;</td></tr>
HTML
	open(CONFIG,"$quiz_file.dat") || dienice("Could not find the config file: $!");
	flock(CONFIG,2); # locking so we dong get f*cked
	$newquestion = 0; #is this a new question?  I will use this to add up total possible
					# points
	$total=0; #initializing total possible points.
	$highest_value = 0; #initializing the highest value for each question
	$question_number =0;
	while(<CONFIG>) {
		chomp;
		if($_ =~ /^\#/) {
			$_ =""; #make sure that I ignore all commented lines
		}
		if($_ =~ /^[qQ]=/) {
			$newquestion = 1;
			$question_number++;
			$total = $total + $highest_value;
			$highest_value =0;
			($nothing,$question) = split(/=/,"$_");
			print "<tr bgcolor=\"$darkrowcolor\">
			<td align=\"left\"><font color=white><b>$question</b></font></td></tr>";
		}
		if($_ =~ /^[aA]=/) {
			$newquestion = 0;
			($nothing,$answer,$answer_value) = split(/=/,"$_");
			if($answer_value > $highest_value) {
				$highest_value = $answer_value;
			}
			print "<tr><td align=\"left\">
			<input type=\"radio\" name=\"answer$question_number\" value=\"$answer_value\">$answer</td></tr>";
		}
		
	}
	close(CONFIG);
	if($newquestion == 0) { #in most cases, we need to add the highest value of the last question
		$total = $total + $highest_value;
	}
print <<HTML;
<tr bgcolor="$darkrowcolor">
	<td align="middle"><font color=white>
	<input type="hidden" name="quiz" value="$quiz_file">
	<input type="hidden" name="question_number" value="$question_number">
	<input type="hidden" name="total" value="$total">
	<input type="hidden" name="mode" value="grademe">
	<input type="submit" value="Grade Me!">
	</font></td>
</tr>
</table>
</form>
</center>
HTML
}

sub grademe {
	$ip = $ENV{"REMOTE_ADDR"};
	$time = localtime(time());
	$quiz_file = $cur->param("quiz");
	$question_number = $cur->param("question_number"); #total number of questions
	$total = $cur->param("total"); #total possible points
	$grade =0; #start with a grade of 0 and add up points
	for($i=1;$i<($question_number+1);$i++) {
		$answer = $cur->param("answer$i");
		$grade = $grade + $answer;
#		print "grade is $grade after $answer.<br>";
		$answerstring = $answerstring . "$i($answer)"; #well, it will at least store how
											#many points they get with each question
	}
	
	#check for a log directory.  If there is not one, make one. It would
	# be better here to use mkdir() and umask() but I dnot know how yet
	if(!(-e "logs")) {
		$status = `mkdir logs`;
		sleep(1);
		if(!(-e "logs")) {
			print "<p>There was no log/ directory to store results in. I tried to make it and then
			checked in 1 second to see if it was there and it is still not there.  Eek!
			This probably means that I do not have enough permissions to create directories
			in my own folder.  Please ask the server admin to give me the proper permissions (only 
			securily done if the scripts exucute as the user).</p>";
		}
	}
	open(LOGOUT,">>logs/$quiz_file") || dienice("<p>I could not write to the log file fro this quiz.
	Tell the web master to give me permissions to write to the log files.  Sorry.</p>");
	flock(LOGOUT,2);
	print LOGOUT "$grade|$ip|$time|$answerstring\n";
	close(LOGOUT);
	
	open(LOGIN,"logs/$quiz_file") || dienice("<p>There is no quiz file (or you do not
	have permissions to read it)! Tell the web master.</p>");
	flock(LOGIN,2);
	while(<LOGIN>){
		chomp;
		($grade_in,$ip_in,$time_in,$answerstring_in)=split(/\|/,"$_");
		push(@grades,$grade_in);
	}
	@grades = sort(@grades); #lets put them in order
	#get an average for the crades
	$number_of_grades = (@grades);
	$sum =0;
	$higher =0;
	$lower=0;
	$same =0;
	foreach $gr (@grades) {
		$sum = $sum + $gr;
		if($gr > $grade) { #number of higher grades
			$higher++;
		}
		if($gr < $grade) { #number of lower grades
			$lower++;
		}
		if($gr == $grade) { #number of the same grades
			$same++;
		}
	}
	$average = $sum/$number_of_grades;
	
	#time to see what the description of our score is
	open(CONFIG,"$quiz_file.dat") || dienice("Could not find the config file: $!");
	flock(CONFIG,2); # locking so we dong get f*cked
	$still_in_description = 0;
	while(<CONFIG>) {
		chomp;
		if($_ =~ /^\#/) {
			$_ =""; #make sure that I ignore all commented lines
		}
		
		if($gradeby eq "percent") {
			if($_ =~ /^(-?\d{1,2})\s*-\s*(-?\d{1,3})\s*%\s*=\s*.*/) {
				$low_level = $1;
				$high_level = $2;
				$still_in_description = 0;
				if(($high_level >= ($grade/$total*100)) && (($grade/$total*100) >= $low_level)) {
					$still_in_description = 1;
				}
			}
			if($still_in_description) {
				$line = $_;
				$line =~ s/^(-?\d{1,2})\s*-\s*(-?\d{1,3})\s*%\s*=\s*/<b>$grade points is in the $1 through $2\ precent<\/b><br>/g;
				$description .= "$line<br>\n";
			}
		}elsif ($gradeby eq "points") {
			if($_ =~ /^(-?\d{1,2})\s*-\s*(-?\d{1,3})\s*\s*=\s*.*/) {
				$low_level = $1;
				$high_level = $2;
				$still_in_description = 0;
				if(($high_level >= $grade) && ($grade >= $low_level)) {
					$still_in_description = 1;
				}
			}
			if($still_in_description) {
				$line = $_;
				$line =~ s/^(-?\d{1,2})\s*-\s*(-?\d{1,3})\s*\s*=\s*/<b>$grade points is in the $1 through $2\ points<\/b><br>/g;
				$description .= "$line<br>\n";
			}		
		} else {
			$description .= "Oops, someone forgot to have a gradeby=number or gradeby=percent in the
			config file!";
		}
		
	}
	close(CONFIG);
	print <<HTML;
<center>
<table cellpadding=5 bgcolor="$tablecolor" border="0" cellspacing="0">
<tr bgcolor="$darkrowcolor">
	<td align=middle><font color=white><b>$title Results</b></td>
</tr>
<tr>
	<td align="middle">
	<font size="+4">Your Score: </font><b><font color="red" size="+4">$grade</font><font size=+4 color=black> / $total</font></b>
	</td>
</tr>
<tr>
	<td>
HTML
	printbar($grade,$total,"YOUR SCORE");
	printbar($average,$total,"AVG SCORE");
	print <<HTML;
	<p><b><font color=red>$number_of_grades </font>have taken this test so far.</b></p>
	<p><b><font color=red>$higher </font>people have scored higher than you.</b></p>
	<p><b><font color=red>$lower </font>people have scored lower than you.</b></p>
	<p><b><font color=red>$same </font>people made the same grade as you.</b></p>
	</td>
</tr>
<tr bgcolor="$darkrowcolor">
	<td align=middle><font color=white><b>What does this mean? *</b></td>
</tr>
<tr><td>$description</td></tr>
<tr><td><font size="-1">* These results are just for fun. Do not sue me.  Have a sense of humor.</font></td></tr>
</table>
</center>
HTML
	
	close(LOGIN);
}

#useage printbar(number,total,"Coolness");
sub printbar {
	my $number_bar = $_[0];
	my $snumber_bar = sprintf "%10.1f",$number_bar;
	my $total_bar = $_[1];
	my $percentage = ($number_bar/$total_bar)*100;
	my $bartitle = $_[2];
	$percentagewidth = $percentage *4;
	print "<br><b><font color=\"#006600\"> $bartitle </font></b><br> ";

	$spercent = sprintf "%10.1f\%",$percentage;

	print <<HTML;
<table border=0 cellpadding=0 cellspacing=0>
    <tr> <td width=$percentagewidth bgcolor=0000ff><font color=white><b>$spercent</b></font>&nbsp;</td>
    	<td><font size="-1">&nbsp;&nbsp;&nbsp; $snumber_bar points out of $total_bar</font></td>
    </tr>
</table>
HTML
}

sub dienice {
	my($msg) = @_;
	print <<HTML;
	<br>
<center><table width="400">
	<tr bgcolor="#FC3C3C"><td align="middle"><b><big>!! Oops !!</big></b></td></tr>
	<tr bgcolor="lightgrey"><td>$msg</td></tr>
</table></center>
</body></html>
HTML
	printendhtml();
	exit;
}

sub dietext {
	my($msg) = @_;
	print "Content-type: text/html\n\n
	Error:\n\n$msg";
	exit;
}
